;dnl.orc
	sr = 44100
	kr = 4410
	ksmps = 10
	nchnls = 1
	instr	1
ifrq	=	cpspch(p5)
iamp	=	ampdb(p4)
kenv	linen	.5,p3/2,p3,p3/2	;envelope (amp ranges 0 to .5)
a1	oscil	kenv,ifrq,1		;sinusoid (oscillates between -.5 and .5)

;waveshaping

a2	table	a1,2,1,.5 	;a1=input signal
				;2=waveshaper table number
				;1= index mode (normalized)
				;.5 offset added to the input signal
a2	=	a2 * iamp

;beside using alternated coefficient signs, as suggested in the text,
;to avoid the DC offset we can also use a highpass filter, such that
;the DC component is eliminated (or attenuated) at the beginning and at the 
;ending of the note - to that aim, cancel the semicolon in the following 
;line and use aout as the ouput signal, not a2.

;aout	atone	a2, 30

	out	a2	 
	endin
 
