;dnl0.orc
	sr = 44100
	kr = 4410
	ksmps = 10
	nchnls = 1

	instr	1

; waveshaping (non-linear distorsion)

ifrq	=	p5
iamp	=	ampdb(p4)

kenv	linseg	 0,.1,.5,p3-.1,0
a1	oscil	kenv, ifrq, 1   	;sinusoid with envelope 
					;scaled between -.5 and .5

a2	=	a1 + .5		;add offset of .5, so
					;sinusoid now oscillates between 0 and 1
a3	table	a2, 2, 1		;use the sinusoid signal, a2, to index 
					;table n.2 (index mode=1, normalized) 
a4	=	a3 * iamp		;amplitude scaling 
	out	a4
	endin
 
