;fm.orc
	sr = 44100
	kr = 2205
	ksmps = 20
	nchnls = 1
	
	instr	1

icamp	=	p4	;carrier amplitude (0-32767)
icfrq	=	p5	;carrier freq(Hz)
imfrq	=	p6	;modulator freq(Hz)
indx	=	p7	;modulation index

;----------------------MODULATOR
amod 	oscili	indx*imfrq,imfrq,1 	;modulator amp argument = imfrq * indx 
					;e.g. if imfrq=1000 and indx =.5	
					;then modulator amp= indx*imfrq=500
;----------------------CARRIER
acar	oscili	icamp,icfrq+amod,1 	;amplitude argument = icamp
					;freq argument = icfrq + amod
	out	acar	
	endin 
 
	instr	2

icamp	=	p4	;carrier amp (0-32767)
ifrq	=	p5	;nominal freq
ipk	=	p6	;carrier freq factor
imk	=	p7	;modulator freq factor
indx	=	p8	;modulation index

aout	foscili	icamp, ifrq, ipk, imk, indx, 1
	out	aout
	endin

