;grain1.orc
	sr	=	22050
	kr	=	22050
	ksmps	=	1
	nchnls	=	1

	instr	1
iskip1	init 	0 
iskip2	init	0 
iamp	=	p4
ifrq	=	p5
ifrqrnd	=	p5/20
idur	=	p6	; grain duration: each grain is followed by 
			; a pause, itself lasting idur seconds
iatkdec	=	p7	; rise time and decay time (symmetrical envelopes)

label:

kenv1	 linseg	0,iatkdec,iamp,idur-iatkdec*2,iamp,iatkdec,0,idur,0
			; the grain envelope is followed by a pause, of the same 				; duration as the grain duration

kfrqrnd	rand	ifrqrnd,-1		; random frequency values
a1	oscili	kenv1, ifrq+kfrqrnd, 1	; grain signal

	timout	0,idur*2,continue	; these opcodes "re-initialize" 
					; the grain envelope every 
					; idur*2 seconds.
	reinit	 label		; that way, many grains are continue:							; generated for each note in the 
	rireturn		; score (see section 17.3)
		
kenvt	linseg	0,p3*.25,1,p3*.5,1,p3*.25,0  ;overall amplitude envelope
	out	a1*kenvt
		endin

