;phmod1.orc
	sr	=	44100
	kr	=	44100
	ksmps	=	1
	nchnls	=	1

	instr	1

ifrq	=	cpspch(p5)
iamp	=	ampdb(p4)
afilt	init	0	;initializes the afilt variable
ifeed	=	p6
iexcdur	=	p7

aexc	linseg	1,ieccdur,0,p3- ieccdur excdur,0
; signal decays from 1 to 0 in iexcdur seconds
; then remains zero for the remainder time
 
asum	= 	aexc+afilt*ifeed	
; sum of aexc and afilt (filter output), 
; feedback control is applied

					; feedback delay line 
adel	delay	asum,1/ifrq		; delay time is the inverse of the required
					; fundamental freq: the higher is the
					; frequency, and the shorter is the time it
 					; takes for the wave to travel across the
 					; string (delay time = period of
					; fundamental frequency)

afilt	tone	adel,p7			; afilt is the delayed signal, passed
					; through a low-pass (the low-pass 
					; simulates energy dissipation) 
aout	atone	afilt*iamp,30		; high-pass to attenuate DC offset
	out	aout
	endin

