sr    	=	44100
kr    	=	147
ksmps  	=	300
nchnls	=	2

gk1	init	1	;1 audio table num
gk2	init	0	;2 playback rate
gk3	init	3	;3 grain repeat rate
gk4	init	1	;4 speed of phase changing
gk5	init	0	;5 end pitch of glissandos
gk6	init	.5	;6 total grain duration 
gk7	init	.3	;7 attack duration of grain 
gk8	init	.3	;8 decay duration of grain 
gk9	init	0	;9 reverb send 
gk10	init	10000	;10 reverb lowpass filter 
gk11	init	0	;11 grain random pitch percent 
gk12	init	0	;12 grain rendom duration percent 
gk13	init	.02	;13 phase difference beetween right/left channels 
gk14	init	0	;14 grain random phase percent 
gk15	init	0	;15 octaviation factor
gk16	init	1	;16 overall volume

gk17	init	102	;17 random harmonic table num
gk18	init	0	;18 random harmonic amount  (table index)
gk19	init	0	;19 random harmonic amount of waveguide synthesis (table index)
gk20	init	2	;20 period of each note of waveguide synthesis
gk21	init	sr/2	;21 filter cutoff frequency of waveguide synthesis
gk22	init	.5	;22 feedback of waveguide synthesis
gk23	init	1	;23 repeat rate left-right deviation factor
gk24	init	0	;24 phase offset
gk25	init	0	;25 grain random tempo
gk26	init	1000	;26 WG excitation signal filter cutoff
gk27	init	.05	;27 WG excitation signal filter resonance
gk28	init	0	;28 filter sweep LFO amplitude
gk29	init	.1	;29 filter sweep LFO frequency
gk30	init	0	;30 WG freq. LFO amplitude
gk31	init	.1	;31 WG freq. LFO frequency



garev1	init	0
gaout1	init	0
gaout2	init	0


;//////////////////////////////////////////
	instr 	1
;//////////////////////////////////////////
ifmidi	cpsmidi	
ifmidi	=	(ifmidi/127)*.98 ;***** raw pitch
iamp	ampmidi	2

ifna	=	int(i(gk1))	;** ifna, input sound file through gen 01
ifna2 	=	ifna
imemlen	=	ftlen(ifna)	;** allocated table length
ilen	=	nsamp(ifna)	;** number of samples
iln2mem	=	ilen/imemlen 	;** sample_length/table_length ratio
ifsr	=	ftsr(ifna)/sr	;** sample rate of table
isr2mem	=	sr/imemlen	;** to compute the normal frequency
isr2dur	=	ftsr(ifna)/ilen

krndpch	trirand gk11		;**  random amount of pitch
krdharm	linrand gk18
krdharm	table	krdharm, i(gk17) ;**  random harmonic amount  
kform	table	gk2, 151
kform   =	isr2mem  * ifmidi * ifsr * kform
kform  	=	cpsoct(octcps(kform * 1000) + krndpch - gk5 / 2) * krdharm / 1000 ;**  playback rate
krnd	trirand	gk25
krnddur	linrand	gk12							;** random amount of duration
;kfund 	= 	cpsoct(octcps(gk3*1000) + krnddur)/1000 		;** repeat rate
kfund 	= 	2^(gk3+krnd-gk25*.45) ;** repeat rate
kphsrate=	gk4*isr2dur
kphs	init	0
kphs2	init	0
kphs	phasor	kphsrate
kphs2	phasor	kphsrate,i(gk13) ;** global phase of right channel is shifted for stereo effect

krndphs	linrand	gk14	;** random phase percent of  each grain 
kphsb	=	(kphs+krndphs) * iln2mem
kphs	=	(kphsb < iln2mem ? kphsb : kphsb-iln2mem)
kphs2b	=	(kphs2+krndphs)* iln2mem
kphs2	=	(kphs2b < iln2mem ? kphs2b : kphs2b-iln2mem)
kphs	=	kphs+gk24
kphs2	=	kphs2+gk24
kgliss	=	gk5			;** Grain glissandos
kdur	=	(1+krnddur) * gk6		
kris	=	kdur * gk7
kdec	=	kdur * gk8
iolaps	=	100

kampenv	linenr	iamp*gk16, 0,.1,.03
;** 		         xfund              koct     kris        kdec          ifna        itotdur     kgliss
;** 		xamp                 xform      kband      kdur        iolaps        ifnb        kphs 
;**		---------------------------------------------------------------------------------------------
a1	fof3	kampenv, kfund,      kform, gk15, 0, kris, kdur, kdec, iolaps, ifna,  101, 1000, kphs, kgliss
a2	fof3	kampenv, kfund*gk23, kform, gk15, 0, kris, kdur, kdec, iolaps, ifna2, 101, 1000, kphs2,kgliss

gaout1	=	gaout1 + a1 / (1 + gk9*2)	;** main out left
gaout2	=	gaout2 + a2 / (1 + gk9*2)	;** main out right

;		outs gaout1,gaout2
	endin




;///////////////////////////////////////
	instr	100
;///////////////////////////////////////
;*** min-max ranges
i1min	init	1	
i1max	init	1.5	
i2min	init	0	
i2max	init	13.5	
i3min	init	.5	
i3max	init	5	
i4min	init	0	
i4max	init	2	
i5min	init	0	
i5max	init	1	
i6min	init	.005	
i6max	init	4	
i7min	init	1/15	
i7max	init	1	
i8min	init	1/15	
i8max	init	1	
i9min	init	0	
i9max	init	.12	
i10min	init	500	
i10max	init	10000	
i11min	init	0	
i11max	init	.5
i12min	init	0	
i12max	init	8
i13min	init	0	
i13max	init	.2
i14min	init	0	
i14max	init	.5
i15min	init	0	
i15max	init	3
i16min	init	.05	
i16max	init	1.5

i17min	init	102	
i17max	init	105.5
i18min	init	0	
i18max	init	8.5
i19min	init	0	
i19max	init	32.5
i20min	init	.1	
i20max	init	4
i21min	init	300	
i21max	init	sr/2
i22min	init	0	
i22max	init	1
i23min	init	1	
i23max	init	1.5
i24min	init	0	
i24max	init	1
i25min	init	0	
i25max	init	15
i26min	init	.15	
i26max	init	3000
i27min	init	.05	
i27max	init	8
i28min	init	0	
i28max	init	10
i29min	init	.05	
i29max	init	10
i30min	init	0	
i30max	init	2
i31min	init	.05	
i31max	init	10


;******  ivalue = (initial_value - min) / (max - min)
	initc7  1,1,(i(gk1)-i1min)/(i1max-i1min)	 
	initc7  1,2,(i(gk2)-i2min)/(i2max-i2min)  	
	initc7  1,3,(i(gk3)-i3min)/(i3max-i3min)   	
	initc7  1,4,(i(gk4)-i4min)/(i4max-i4min)	
	initc7  1,5,(i(gk5)-i5min)/(i5max-i5min)	
	initc7  1,6,(i(gk6)-i6min)/(i6max-i6min)	
	initc7  1,7,(i(gk7)-i7min)/(i7max-i7min)	
	initc7  1,8,(i(gk8)-i8min)/(i8max-i8min)	
	initc7  1,9,(i(gk9)-i9min)/(i8max-i9min)	
	initc7  1,10,(i(gk10)-i10min)/(i10max-i10min)
	initc7  1,11,(i(gk11)-i11min)/(i11max-i11min)
	initc7  1,12,(i(gk12)-i12min)/(i12max-i12min)
	initc7  1,13,(i(gk13)-i13min)/(i13max-i13min)
	initc7  1,14,(i(gk14)-i14min)/(i14max-i14min)
	initc7  1,15,(i(gk15)-i15min)/(i15max-i15min)
	initc7  1,16,(i(gk16)-i16min)/(i16max-i16min)
	initc7  1,17,(i(gk17)-i17min)/(i17max-i17min)
	initc7  1,18,(i(gk18)-i18min)/(i18max-i18min)
	initc7  1,19,(i(gk19)-i19min)/(i19max-i19min)
	initc7  1,20,(i(gk20)-i20min)/(i20max-i20min)
	initc7  1,21,(i(gk21)-i21min)/(i21max-i21min)
	initc7  1,22,(i(gk22)-i22min)/(i22max-i22min)
	initc7  1,23,(i(gk23)-i23min)/(i23max-i23min)
	initc7  1,24,(i(gk24)-i24min)/(i24max-i24min)
	initc7  1,25,(i(gk25)-i25min)/(i25max-i25min)
	initc7  1,26,(i(gk26)-i26min)/(i26max-i26min)
	initc7  1,27,(i(gk27)-i27min)/(i27max-i27min)
	initc7  1,28,(i(gk28)-i28min)/(i28max-i28min)
	initc7  1,29,(i(gk29)-i29min)/(i29max-i29min)
	initc7  1,30,(i(gk30)-i30min)/(i30max-i30min)
	initc7  1,31,(i(gk31)-i31min)/(i31max-i31min)


gk1	ctrl7	1,1,i1min,i1max 	
gk2	ctrl7	1,2,i2min,i2max	
gk3	ctrl7	1,3,i3min,i3max 
gk4	ctrl7	1,4,i4min,i4max	
gk5	ctrl7	1,5,i5min,i5max	
gk6	ctrl7	1,6,i6min,i6max,100
gk7	ctrl7	1,7,i7min,i7max	
gk8	ctrl7	1,8,i8min,i8max	
gk9	ctrl7	1,9,i9min,i9max
gk10	ctrl7	1,10,i10min,i10max,100
gk11	ctrl7	1,11,i11min,i11max	
gk12	ctrl7	1,12,i12min,i12max	
gk13	ctrl7	1,13,i13min,i13max	
gk14	ctrl7	1,14,i14min,i14max	
gk15	ctrl7	1,15,i15min,i15max	
gk16	ctrl7	1,16,i16min,i16max	
gk17	ctrl7	1,17,i17min,i17max	
gk18	ctrl7	1,18,i18min,i18max	
gk19	ctrl7	1,19,i19min,i19max	
gk20	ctrl7	1,20,i20min,i20max	
gk21	ctrl7	1,21,i21min,i21max	
gk22	ctrl7	1,22,i22min,i22max	
gk23	ctrl7	1,23,i23min,i23max
gk24	ctrl7	1,24,i24min,i24max
gk25	ctrl7	1,25,i25min,i25max
gk26	ctrl7	1,26,i26min,i26max,100
gk27	ctrl7	1,27,i26min,i27max,100
gk28	ctrl7	1,28,i28min,i28max,100
gk29	ctrl7	1,29,i29min,i29max,100
gk30	ctrl7	1,30,i30min,i30max,100
gk31	ctrl7	1,31,i31min,i31max,100


;************ PHYSICAL WAVEGUIDE MODEL MODIFY THE INPUT SIGNAL ************
ibasefreq	=	30.5;61

kindx1	randh	gk19,1/gk20
kindx2	randh	gk19,1/gk20,.12345


kcps1	table	kindx1, 150
kcps2	table	kindx2, 150
;kcps1	portk	kcps1,.05
;kcps2	portk	kcps2,.05
kcps1	tonek	kcps1,13
kcps2	tonek	kcps2,13
;kcps1	diff	kcps1
;kcps2	diff	kcps2	
acps1	interp	kcps1
acps2	interp	kcps2	
k1	oscili	gk28,gk29,160 ; LFO for filter sweep
k1	=	(2 ^ k1) * gk26
k1	= 	(k1 > 10000) ? 10000 : k1
a1	lowres	gaout1,k1,gk27
a2	lowres	gaout2,k1,gk27
k1a	oscili	gk30,gk31,161
k1	=	powoftwo(k1a)
k2	=	powoftwo(-k1a)

ak1	interp	k1
ak2	interp	k2

a1	physic1 a1,acps1*ibasefreq*ak1,gk21,gk22
a2	physic1 a2,acps2*ibasefreq*ak2,gk21,gk22



;************ REVERB *************
garev1	=	(a1 + a2) * gk9	;** reverb send
arevb	tonex	garev1, gk10,2
arev	reverb2	arevb, 9, .05
	outs	a1 + arev, a2 + arev
;	outs	gaout1, gaout2
	clear 	gaout1, gaout2,  garev1
	endin


